{ lib, config, pkgs, ...  }:

with lib;
let
  cfg = config.modules.desktop.polkit-gnome;
in {
  options.modules.desktop.polkit-gnome = {
    enable = mkEnableOption "Enable polkit-gnome, a simple polkit agent";
  };

  config = mkIf cfg.enable {
    systemd.user.services.polkit-gnome-authentication-agent-1 = {
      description = "polkit-gnome-authentication-agent-1";

      wantedBy = [ "graphical-session.target" ];
      wants = [ "graphical-session.target" ];
      after = [ "graphical-session.target" ];

      serviceConfig = {
        Type = "simple";
        ExecStart = "${pkgs.polkit_gnome}/libexec/polkit-gnome-authentication-agent-1";
        Restart = "on-failure";
        RestartSec = 1;
        TimeoutStopSec = 10;
      };
    };
  };
}
